module SQLBeauty where 
import qualified SQLModel as SQL
import PPrint 
import List




isIndenter (SQL.Indenter _) = True
isIndenter _              = False

equalIndenting x y =  (isIndenter x) == (isIndenter y)


groupedSQL xs = groupBy equalIndenting xs
beautyGroup xs@(x:_) = if (isIndenter x) then vsep (map beautyItem xs)
								         else indent 4 (hsep (map beautyItem xs))
beauty xs = vsep (map beautyGroup (groupedSQL xs))

beautyItem (SQL.Indenter s) = text s
beautyItem (SQL.Text s) = text s
beautyItem (SQL.Parens x) = text "(" <$> (indent 4 (beauty x)) <$> text ")" 